#include "../fragments/header.glsl"
#include "../fragments/transforms.glsl"

#define ENTITY_TILE_OFFSET_X (MAP_TILE_WIDTH - ENTITY_WIDTH) / 2
#define ENTITY_TILE_OFFSET_Y (MAP_TILE_HEIGHT - ENTITY_HEIGHT) / 2

struct Entity {
  int x;
  int y;
  int tileset;
  int tile;
};

layout(std140) uniform b_Data {
  Entity entities[MAP_ENTITY_COUNT_MAX];
  int entityCount;
};

vec4 entityGetCoordinates(Entity ent) {
  int vx = (ent.x * MAP_TILE_WIDTH) + ENTITY_TILE_OFFSET_X;
  int vy = (ent.y * MAP_TILE_HEIGHT) + ENTITY_TILE_OFFSET_Y;
  return vec4(vx, vy, vx + ENTITY_WIDTH, vy + ENTITY_HEIGHT);
}

vec4 entityGetUVs(Entity ent) {
  return tilesetGetUVsByIndex(ent.tileset, ent.tile);
}